<?php

namespace App\Http\Controllers\saleAdministration\singleCustomer;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\CustomerRecieved;
use App\Models\Currency;
use App\Models\Customer;
use App\Models\CashJournal;
use App\Models\CustomerBill;
use Auth;

class SCustomerRecievedController extends Controller
{
    public function index($id)
    {
        $data = CustomerRecieved::where('customer_id', $id)->orderBy('id', 'desc')->paginate(10);
        $customer = Customer::find($id);
        return view('sale.customers.receiveds.index', compact('data', 'customer'));
    }
    public function create($id)
    {
        $customer = Customer::find($id);
        $currencies = Currency::all();
        $invoice_number = CustomerRecieved::orderBy('id', 'desc')->get()->first();
        $number = "";
        // if ($invoice_number == "") {
        //     $number = $invoice_number = 1;
        // } else {
        //     $number = $invoice_number->invoice_number + 1;
        // }
        return view('sale.customers.receiveds.create', compact('customer', 'currencies','number'));
    }
    public function store(Request $request)
    {
        $data = new CustomerRecieved();
        $data->title = $request->title;
        $data->recieved_number = $request->invoice_number;
        $data->amount = $request->amount;
        $data->date = $request->date;
        $data->currency_id = $request->currency_id;
        $data->ex_rate = $request->ex_rate;
        $data->customer_id = $request->customer_id;
        $data->c_target = $request->cash_id;
        $data->details = $request->details;
        $data->save();
        if($data){
            if ($request->cash_id == 1) {
                $cash = new CashJournal();
                $cash->title = $data->title . " Invoice" . $data->recieved_number;
                $cash->date = $data->date;
                $cash->income = $data->amount;
                $cash->currency_id = $data->currency_id;
                $cash->ex_rate = $data->ex_rate;
                $cash->module_id = 20;
                $cash->type_id = 20;
                $cash->module_record_id = $data->id;
                $cash->user_id = Auth::user()->id;
                $cash->details = "Cash Targer From Received";
                $cash->save();
            }
        }
        session()->flash("msg", "Success!");
        return redirect()->route('customer_single_received.index', $request->customer_id);
    }
    public function edit($id)
    {
        $data = CustomerRecieved::find($id);
        $customer = Customer::find($data->customer_id);
        $currencies = Currency::all();
        return view('sale.customers.receiveds.edit', compact('data', 'customer', 'currencies'));
    }

    public function show($id){
        $data = CustomerRecieved::find($id);
        $balance=CustomerBill::where('customer_id',$data->customer_id)->where('currency_id',$data->currency_id)->sum('grand_total');
        $tbalance=$balance-$data->amount;
        return view('sale.customers.receiveds.show',compact('data','tbalance'));

    }
    public function update(Request $request, $id)
    {
        $request->validate([
            'amount' => 'required',
            'date' => 'required',
        ]);
        $data = CustomerRecieved::find($id);
        $data->title = $request->title;
        $data->recieved_number = $request->invoice_number;
        $data->amount = $request->amount;
        $data->date = $request->date;
        $data->currency_id = $request->currency_id;
        $data->ex_rate = $request->ex_rate;
        $data->customer_id = $request->customer_id;
        $data->c_target = $request->cash_id;
        $data->details = $request->details;
        $data->save();
        if ($data) {
            if ($request->cash_id == 1) {
                $cash = CashJournal::where('module_id', 20)->where('module_record_id', $data->id)->first();
                if ($cash != null) {
                    $cash->title = $data->title."Recived".$data->recieved_number;
                    $cash->date = $data->date;
                    $cash->income = $data->amount;
                    $cash->currency_id = $data->currency_id;
                    $cash->module_id = 20;
                    $cash->type_id = 20;
                    $cash->module_record_id = $data->id;
                    $cash->user_id = Auth::user()->id;
                    $cash->details = "Cash Targer From Received";
                    $cash->save();
                } else {
                    $cash = new CashJournal();
                    $cash->title = $data->title." Invoice".$data->invoice_number;
                    $cash->date = $data->date;
                    $cash->income = $data->amount;
                    $cash->currency_id = $data->currency_id;
                    $cash->module_id = 20;
                    $cash->type_id = 20;
                    $cash->module_record_id = $data->id;
                    $cash->user_id = Auth::user()->id;
                    $cash->details = "Cash Targer From Received";
                    $cash->save();
                }
            }else{
                $cash = CashJournal::where('module_id', 20)->where('module_record_id', $data->id)->delete();
            }
            session()->flash("msg", "Success!");
            return redirect()->route('customer_single_received.index', $request->customer_id);
        }

    }
    public function delete($id)
    {
        $recieved = CustomerRecieved::find($id)->delete();
        if ($recieved) {
            $cash = CashJournal::where('module_id', 20)->where('module_record_id', $id)->delete();
            session()->flash("msg", "Success!");
            return back();
        }

    }
    public function report_show($id)
    {
        $currencies = Currency::all();
        return view('sale.customers.receiveds.report', compact('id', 'currencies'));
    }
    public function report_find(Request $request)
    {
        $bname=\App\Models\Info::find(1)->business_name;
        $fDate = $request->fromDate;
        $tDate = $request->toDate;
         $customer_id = $request->customer_id;
        $currency_id = $request->currency_id;
        $Customer = Customer::find($customer_id);
        $currency = Currency::find($currency_id);
        $data = "";
        if ($currency_id == "all") {
            $Recieveds = CustomerRecieved::whereBetween('date', [$fDate, $tDate])->where('customer_id', $customer_id)->get();
            $data .= "<h6 style='text-align:center;'>".$bname."</h6>";
            $data .= "<h6 style='text-align:center;'>$Customer->name </h6><p style='text-align:center;'>From ($fDate) to ($tDate)</p>";
            $data .= "<h6 style='text-align:center;'>Recieved Report</h6>";

            $data .= "<h6 style='text-align:center;'> Print Date</h6><p style='text-align:center;'>" . date('Y-m-d') . "</p>";
            $data .= '<table class="" id="table_style">';
            $data .= '<tr>';
            $data .= '<th>#</th>';
            $data .= '<th># Number</th>';
            $data .= '<th>Title</th>';
            $data .= '<th>Date</th>';
            $data .= '<th>Recieved</th>';
            $data .= '<th>Details</th>';
            $data .= '</tr>';
            $data .= '<tbody>';
            $i = 1;
            foreach ($Recieveds as $row) {
                $data .= "<tr>";
                $data .= "<td>" . $i . "</td>";
                $data .= "<td>" . $row->recieved_number . "</td>";
                $data .= "<td>" . $row->title . "</td>";
                $data .= "<td>" . $row->date . "</td>";
                $data .= "<td>" . $row->amount . " " . $row->currency->title_en . " </td>";
                $data .= "<td>" . $row->details . "</td>";
                $data .= "</tr>";
                $i++;
            }
            if ($i == 1) {
                $data .= "<tr><td colspan='6' style='text-align:center;'>No data Available!</td></tr>";
            }
            $data .= "</tbody>";
            $data .= '</table>';
            $data .= '</table>';
            $data .= '<table class="">';
            $data .= ' <tr>';
            $data .= '<th colspan="3" rowspan="2">Sub Total</th>';
            $data .= '<th colspan="4" class="">Recieved</th>';
            $data .= ' </tr>';
            $data .= ' <tr>';
            foreach (Currency::all() as $row) {
                $Recieved = CustomerRecieved::where('currency_id', $row->id)->whereBetween('date', [$fDate, $tDate])->sum('amount');
                $data .= '<td style="">' . $row->title_en . "/" . $Recieved . '</td>';
            }
            $data .= '</tr>';
            $data .= '</table>';
        } else {
            $Recieveds = CustomerRecieved::whereBetween('date', [$fDate, $tDate])->where('customer_id', $customer_id)->where('currency_id', $currency_id)->get();
            $data .= "<h6 style='text-align:center;'>".$bname."</h6>";
            $data .= "<h6 style='text-align:center;'>$Customer->name</h6><p style='text-align:center;'>From ($fDate) to ($tDate)</p>";
            $data .= "<h6 style='text-align:center;'>Recieved Report</h6>";
            $data .= "<h6 style='text-align:center;'>$currency->title_en currency</h6>";
            $data .= '<table class="" id="table_style">';
            $data .= '<tr>';
            $data .= '<th>#</th>';
            $data .= '<th># Number</th>';
            $data .= '<th>Title</th>';
            $data .= '<th>Date</th>';
            $data .= '<th>Recieved</th>';
            $data .= '<th>Details</th>';
            $data .= '</tr>';
            $data .= '<tbody>';
            $i = 1;
            foreach ($Recieveds as $row) {
                $data .= "<tr>";
                $data .= "<td>" . $i . "</td>";
                $data .= "<td>" . $row->recieved_number . "</td>";
                $data .= "<td>" . $row->title . "</td>";
                $data .= "<td>" . $row->date . "</td>";
                $data .= "<td>" . $row->amount . " " . $row->currency->title_en . " </td>";
                $data .= "<td>" . $row->details . "</td>";
                $data .= "</tr>";
                $i++;
            }
            if ($i == 1) {
                $data .= "<tr><td colspan='6' style='text-align:center;'>No data Available!</td></tr>";
            }
            $data .= "</tbody>";
            $data .= '</table>';
            $data .= '</table>';
            $data .= '<table class="">';
            $data .= ' <tr>';
            $data .= '<th colspan="3" rowspan="2">Sub Total</th>';
            $data .= '<th colspan="4" class="">' . $Recieveds->sum('amount') . '</th>';
            $data .= ' </tr>';

            $data .= '</table>';
        }
        return $data;
    }
    public function filter_find(Request $request)
    {

        if ($request->type_id == 1) {
                $data = CustomerRecieved::Where('recieved_number', $request->number)
                ->where('customer_id', $request->customer_id)
                ->paginate(10);
        } else if ($request->type_id == 2) {
            $data = CustomerRecieved::Where('title','like',"%".$request->title."%")
                ->where('customer_id', $request->customer_id)
                ->paginate(10);
        } else {
            $data = CustomerRecieved::WhereBetween('date', [$request->fromDate, $request->toDate])
                ->where('customer_id', $request->customer_id)
                ->paginate(10);
        }
        $customer = Customer::find($request->customer_id);
        return view('sale.customers.receiveds.index', compact('data', 'customer'));
    }



}
